﻿
@{
    Layout = null;
}

<!DOCTYPE html>

<html>
<head>
    <meta name="viewport" content="width=device-width" />
    <link href="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-Gn5384xqQ1aoWXA+058RXPxPg6fy4IWvTNh0E263XmFcJlSAwiGgFAW/dAiS6JXm" crossorigin="anonymous">
    <script src="~/js/signalr.js"></script>
    <title>Index</title>
</head>
<body>
    <table class="table" id="train-board">
    <colgroup span="6"></colgroup>
    <tr>
        <th>Origin</th>
        <th>Time</th>
        <th>Destination</th>
        <th>Train#</th>
        <th>Track</th>
        <th>Status</th>
    </tr>
    </table>
    <script>
        window.onload = function () {
           /* var transport = signalR.TransportType.WebSockets;
            var connection = new signalR.HubConnection("http://${document.location.host}/trains", { transport: transport });
            connection.on('broadcastMessage', (boardItems) => {
                var tableRef = document.getElementById('train-board');
                boardItems.forEach(function (d) {
                    insertTrainRow(tableRef, d);

                });

            });*/



            // Insert a row in the table at row index 0

            window.board = new TrainBoard('train-board');

            //window.setInterval(updateData, 5000);
            updateData();
        }

        function updateData(){
            fetch('/api/board').then(function (response) {
                return response.json();
            })
                .then(window.board.initializeBoard.bind(board));
        }

        class TrainBoard {

            constructor(boardId) {
                this.board = document.getElementById(boardId);
            }

            initializeBoard(board) {
                this.updateBoard(board.items);
                var transport = signalR.TransportType.WebSockets;
                var connection = new signalR.HubConnection(board.updateChannel, { transport: transport });
                connection.on('broadcastMessage', this.updateBoard.bind(this));
                connection.start();
            }

            updateBoard(boardRows) {
                this.clearBoard();
                boardRows.forEach(this.insertTrainRow.bind(this));
            }

            clearBoard() {
                for (var i = this.board.rows.length; i > 1; i--) {
                    this.board.deleteRow(i - 1);
                }
            }


             insertTrainRow(data) {
                var row = this.board.insertRow(-1);
                this.insertTableCell(row, data.origin);
                this.insertTableCell(row, new Date(data.departureTime).toLocaleTimeString());
                this.insertTableCell(row, data.destination);
                this.insertTableCell(row, data.trainNumber);
                this.insertTableCell(row, data.track);
                this.insertTableCell(row, data.status);

            }
            
            insertTableCell(row, text) {
                var newCell = row.insertCell(-1);
                var newText = document.createTextNode(text);
                newCell.appendChild(newText);
            }
        }
    </script>
</body>
</html>
